> For the complete documentation index, see [llms.txt](https://docs.kasko.io/kasko-frontend-documentation/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.kasko.io/kasko-frontend-documentation/guides/required-requests.md).

# Setting required requests

It is possible to finish webapps flow and not call any API requests if some fields are somehow skipped or forgotten about. With required requests guard, it is possible to defined requests that need to be fired before user opens certain screen.

## Usage

In flow screen add `required_requests` parameter. It's an array of `strings` | `JsonLogic` that represents request types that should be completed before the screen is shown. The string values can be any request type enabled in the manifest (e.g. `quote`, `policy`, `lead`, `payment`, `claim`, `otp_fnol`, etc.), and JsonLogic can resolve to one of those types.

If API request was not made it will throw error and user will be presented with a generic error message and we'll be notified by Bugsnag, that this situation occurred.

Example:

```js
{
  // ...
  "flow": [
    {
      "path": "first",
      "required_requests": [
        "quote"
      ],
      "components": []
    },
    {
      "path": "success",
      "required_requests": [
        "policy"
      ],
      "components": []
    }
  ]
}
```

It is possible to define logic for required requests, for example if some requests should be fired when some input value is set.

```js
{
  // ...
  "flow": [
    {
      "path": "success",
      "required_requests": [
        "policy",
        "quote",
        {
          "type": "jsonlogic",
          "schema": {
            "if": [
              {
                "var": "input.save_for_later"
              },
              "lead"
            ]
          }
        }
      ],
      "components": []
    }
  ]
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.kasko.io/kasko-frontend-documentation/guides/required-requests.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
